// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html

var WxCommon = require("../extra/WxCommon")

cc.Class({
    extends: cc.Component,

    properties: {
        scoreDisPlay: { //玩家计分
            default: null,
            type: cc.Label
        },
        goldDisPlay: {  //玩家金币
            default: null,
            type: cc.Label
        },
        // scoreSpPrefab: {  //加分骨骼动画
        //     default: null,
        //     type: cc.Prefab
        // },

        _cntCurrStageProp:0,    //本局的道具使用数
        _cntCurrGold:0,         //本局获得金币数
    },

    onLoad: function () {
        this._scoreTempAmount = 0; //分数临时总数
        this._moveDistance = 0;
        this._gameLevel = 0;
        this.scoreDisPlay.string =0;
        this.goldDisPlay.string = 0;
        this._parentScript = this.node.parent.getComponent('Gamejs');
        

        //添加 骨骼动画
        // this._newScoreSp = cc.instantiate(this.scoreSpPrefab);
        // this.node.addChild(this._newScoreSp);
        // this._newScoreSp.position = this.timeDisPlay.node.parent.position;
        // this._newScoreSp.active = false;
    },

    onGameStart: function () {
        this._scoreTempAmount = 0; //分数临时总数
        this._moveDistance = 0;

        this.scoreDisPlay.string = 0 + "m" ;
        this.goldDisPlay.string = 0 ;

        this._cntCurrStageProp = 0;   
        this._cntCurrGold = 0;       
    },

    gameOver: function () {
        //设置历史最高分
        //let historyScore = UserInfo.getString('historyScore');
        //UserInfo.setString('historyScore', historyScore);
        let highScore = UserInfo.getScore();
        let currentScore = parseInt(this.scoreDisPlay.string);
        // if (currentScore > historyScore) {
        //     UserInfo.setString('historyScore', this.scoreDisPlay.string);
        // }
        if (currentScore > highScore) {
            UserInfo.setScore(currentScore);
        }
        UserInfo.setString("currentScore", this.scoreDisPlay.string);
        UserInfo.setString("currentGold", this.goldDisPlay.string);         

        //var level = this.celLevel();
        //var currLevel = parseInt(UserInfo.getCurrentLevel());

        //level = level > currLevel ? level:currLevel;
        var data = [{ key: UserInfo.getCurWeekScoreValue(), value: UserInfo.getScore().toString() },
        { key: "driLevel", value: '0' } ];

        if (UserInfo.platform == 1 && cc.vv.isRank) {
            this.updateXYXScore('showMyRank',data);
        }
    },

    updateXYXScore(strFun, data) {
        wx.setUserCloudStorage({
            KVDataList: data,
            success: function (res) {
                wx.postMessage({
                    method: strFun
                });
            },
            fail: function (res) {
                console.error(res);
            },
            complete: function (res) {
            }
        })
    },

    update: function (dt) {
        if (!this._parentScript.isGameStart) return;

        if(!this._parentScript.isBgRun) return;
        this._moveDistance++;
        if(this._moveDistance%25 == 0)
        {
            this._scoreTempAmount = this._moveDistance/25;
            this.scoreDisPlay.string = this._scoreTempAmount + "m" ;
            this.setGameLevel();
        }
    },

    addCurrGold: function(value)
    {
        this.goldDisPlay.string = parseInt(this.goldDisPlay.string) + value + "";
        this.goldDisPlay.node.runAction(cc.sequence(cc.scaleTo(0.1, 1.0), cc.delayTime(0.5), cc.scaleTo(0.1, 0.7)));
        this.goldDisPlay.node.parent.getChildByName("GoldSprite").runAction(cc.rotateBy(0.7, 360));
    },

    setGameLevel: function()
    {
        var gameScore = this._moveDistance/25;
        if(gameScore <= 50)
        {
            this._gameLevel = 1;
        }
        else if(gameScore > 50 && gameScore <= 100)
        {
            this._gameLevel = 2;
        }
        else if(gameScore > 100 && gameScore <= 200)
        {
            this._gameLevel = 3;
        }
        else
        {
            this._gameLevel = 4;
        }
    },

    getGameLevel: function()
    {
        return this._gameLevel;
    },

    addCurrStageProp: function (value) {
        this._cntCurrStageProp += value;
        UserInfo.addStageProp(value);
    },
});
