// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html
var WxCommon = require("../extra/WxCommon");

cc.Class({
    extends: cc.Component,

    properties: {
        highScoreHistory: { //历史最高分
            default: null,
            type: cc.Label
        },
        currentScore: { //当前得分
            default: null,
            type: cc.Label
        },
        currentGold: { //当前获得金币
            default: null,
            type: cc.Label
        },

        overNode: { //结束节点
            default: null,
            type: cc.Node
        },
        shareNode: { //分享续命节点
            default: null,
            type: cc.Node
        },
        shareDJS: { //分享倒计时
            default: null,
            type: cc.Label
        },
        coinCount: { //当前复活币
            default: null,
            type: cc.Label
        },
        haveShare: null,
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad() {
        this.djsTime = 11.0;
    },

    update(dt) {

        if (parseInt(this.coinCount.string) > 0 && this.djsTime > 0 && this.haveShare) {
            this.djsTime -= dt;
            if (this.djsTime < 0) {
                this.djsTime = 0;
            }
            this.shareDJS.string = parseInt(this.djsTime);
        } 
        else {
            if (this.djsTime >= 0) {
                this.onSkipShare();
                this.djsTime = -1;
            }
        }
    },

    onEnable() {
        //console.log("游戏结束");
        this.currentScore.string = UserInfo.getString("currentScore");
        this.currentGold.string = UserInfo.getString("currentGold");
        this.coinCount.string = UserInfo.getString("coinCount");
        this.highScoreHistory.string = "历史最高分：" + UserInfo.getScore();

        if (parseInt(UserInfo.getString("shareWXCount")) > 0)
            this.haveShare = true;
        else
            this.haveShare = false;

        if (parseInt(this.coinCount.string) > 0 && this.haveShare) 
        {
            this.shareNode.active = true;
            this.overNode.active = false;
            this.djsTime = 11.0;
        } else {
            this.shareNode.active = false;
            this.overNode.active = true;

            this.node.parent.getComponent("Gamejs").showRank();
        }
    },

    onComeBack: function()
    {
        //this.coinCount.string = UserInfo.getString("coinCount") - 1;
        //UserInfo.setString("currentScore", this.coinCount.string);
        this.node.parent.getComponent("Gamejs").comeBack();
    },

    // onShareWX: function () {
    //     //console.log("进入分享");
    //     if (UserInfo.platform == 1) {
    //         var data = {
    //             titleData: UserInfo.shareDesc,
    //             imgurlData: UserInfo.shareUrl,
    //             queryData: 'pp=pp'
    //         };
    //         WxCommon.ShareAppMessage(data, this.node.parent.getComponent("Gamejs"), this.node.parent.getComponent("Gamejs").comeBack);
    //     }
    //     // this.node.parent.getComponent("Gamejs").comeBack(1);
    // },

    //跳过分享
    onSkipShare: function () {
        this.djsTime = -1;
        this.haveShare = false;
        this.shareNode.active = false;
        this.overNode.active = true;

        this.node.parent.getComponent("Gamejs").showRank();

        //var level = parseInt(UserInfo.getCurrentLevel());
        //var newLevel = level;
        // var arrLevel = this.node.parent.parent.getChildByName("LevelInfo").getComponent("LevelJs").enumCompleteLevel();
        // if (arrLevel.length > 0) {
        //     this.showLevelAward(arrLevel);
        //     newLevel = arrLevel[arrLevel.length-1];
        // }

        //UserInfo.setCurrentLevel(newLevel > level?newLevel:level);    
    },

    showLevelAward: function (arrLevel) {
        var pos = 0;
        var nodeLevel = this.node.parent.getChildByName("LevelAward");

        nodeLevel.active = true;
        var ani = nodeLevel.getChildByName("sign").getComponent(sp.Skeleton);
        ani.setAnimation(0, arrLevel[pos] + 'a', false);

        var jsLevel = this.node.parent.parent.getChildByName("LevelInfo").getComponent("LevelJs");
        var name = jsLevel.LevelName(arrLevel[pos]);
        nodeLevel.getChildByName("title").getComponent(cc.RichText).string = "<color=#ffffff>恭喜您达成</c><color=#ff54ff>" + name + "</c><color=#ffffff>头衔</color>";

        var self = this;
        var end = function (data) {
            pos++;
            if (pos >= arrLevel.length) {
                ani.setCompleteListener(null);
                ani.setAnimation(0, arrLevel[pos - 1] + 'b', true);
            } else {
                name = jsLevel.LevelName(arrLevel[pos]);
                nodeLevel.getChildByName("title").getComponent(cc.RichText).string = "<color=#ffffff>恭喜您达成</c><color=#ff54ff>" + name + "</c><color=#ffffff>头衔</color>";
                ani.setAnimation(0, arrLevel[pos] + 'a', false);
            }
            //UserInfo.setCurrentLevel(level);
        }
        ani.setCompleteListener(end);
    },

    onCloseLevelAward: function () {
        var level = parseInt(UserInfo.getCurrentLevel());
        var newLevel = this.node.parent.getChildByName("GameInfo").getComponent("GameInfoJS").celLevel();

        var nodeLevel = this.node.parent.getChildByName("LevelAward");
        var ani = nodeLevel.getChildByName("sign").getComponent(sp.Skeleton);
        ani.setCompleteListener(null);
        nodeLevel.active = false;
    },


    //发起挑战
    onChanllenge: function () {
        //console.log("进入分享");
        var sharedesc = "我突鸡了" + this.currentScore.string + ",快来挑战我";
        // if (minTen + minUnit > 0) {
        //     let minxx = minTen*10 + minUnit;
        //     let secxx = SecTen*10 + SecUnit;
        // 	if (secxx > 0) {
        // 		sharedesc = '我坚持了' + minxx + '分' + secxx + '秒，快来挑战我';
        // 	} else {
        // 		sharedesc = '我坚持了' + minxx + '分，快来挑战我';
        // 	}
        // } else {
        //     let secxx = SecTen*10 + SecUnit;
        //     sharedesc = '我坚持了' + secxx + '秒，快来挑战我';
        // }
        var data = {
            titleData: sharedesc,
            imgurlData: UserInfo.shareUrl,
            queryData: 'pp=pp'
        }
        WxCommon.ShareAppMessage(data, this, null);
        //this.node.parent.getComponent("Gamejs").comeBack();
    },
});