var WxCommon = require("../extra/WxCommon")

cc.Class({
    extends: cc.Component,

    properties: {
          
        sceneManager: { //节点管理(模拟scene)
            default: null,
            type: cc.Node
        },

        bgNode: {  
            default: null,
            type: cc.Node
        },

        bg1Node: {
            default: null,
            type: cc.Node
        },
        bgspeed:100,

        prisonerNode: {  //人物
            default: null,
            type: cc.Node
        },

        propNode: { //道具节点
            default: null,
            type: cc.Node
        },

        lightNode: {  //灯光
            default: null,
            type: cc.Node
        },

        gameInfoNode: { //游戏信息
            default: null,
            type: cc.Node
        },

        gameOverNode: { //游戏结束
            default: null,
            type: cc.Node
        },

        bgMusic: { //背景音乐
            default: null,
            url: cc.AudioClip
        },

        ShareStrategyNode: {//游戏攻略图片节点
            default: null,
            type: cc.Node
        },

        feiendrank: {
            default: null,
            type: cc.Sprite
        },

        SignAtlas:{
            default:null,
            type:cc.SpriteAtlas,
        },

        feiendtex: null,
        otherGamesIndex : 0,
        timerid : null,
    },


    onLoad () 
    {
        //开启物理引擎
        cc.director.getPhysicsManager().enabled = true;
        //开启碰撞引擎
        var manager = cc.director.getCollisionManager();
        manager.enabled = true;
        //manager.enabledDebugDraw = true;
        //manager.enabledDrawBoundingBox = true;

        //添加触摸事件
        // this.ShareStrategyNode.on(cc.Node.EventType.TOUCH_END, this.onTouchEndShare, this);
        this.node.on(cc.Node.EventType.TOUCH_CANCEL, this.onTouchEnd, this);
        this.node.on(cc.Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchBegin, this);

        //脚本绑定
        this._prisonerScript = this.prisonerNode.getComponent("prisonerNodeJs");
        this._lightScript = this.lightNode.getComponent("lightNodeJs");
        this._gameOverNodeScript = this.gameOverNode.getComponent('GameOverNodeJs');
        this._gameInfoScript = this.gameInfoNode.getComponent("GameInfoJs");
        this._propScript = this.propNode.getComponent("PropNodeJs");

        this.isGameStart = false; 
        this.isBgRun = false;
        this._moveDistance = 0;
        //添加消息事件
        this.onMessage();
    },

    onEnable: function () {
        this.onGameStart();
    },

    onDisable: function () {
        cc.audioEngine.uncache(this.bgMusic);
    },

    onMessage: function () {
        gEvent.on("addGold", this.addGold, this);
    },

    onDestroy: function () {
        gEvent.off("addGold", this.addGold, this);
    },

    onGameStart: function () 
    {
        console.log("游戏开始");
        cc.audioEngine.playMusic(this.bgMusic, true, 0.5);

        //游戏开始的时候给一次分享机会
        //UserInfo.setString("coinCount", 5);
        UserInfo.setString("shareWXCount", 1);

        this.isGameStart = true;
        this.isBgRun = true;

        this.gameOverNode.active = false;
        this.propNode.active = true;
        this.resetBgNode();
        this._lightScript.onGameStart();
        this._prisonerScript.onGameStart();
        this._gameInfoScript.onGameStart();
        this._propScript.onGameStart();

        if (UserInfo.platform == 1 && cc.vv.isRank) {
            wx.postMessage({
                method: 'hideRank',
                data: "false"
            });
            cc.find("Canvas/PHB").active = false;
            this.node.getChildByName("PHB").active = false;
        }
    },

    resetBgNode: function()
    {
        this.bgNode.setPosition(cc.v2(0,0));
        this.bg1Node.setPosition(cc.v2(0,2001));
    },
        
    gameOver: function()
    {
        //this.node.getChildByName("GameOver").active = true;
        this.isBgRun = false;
        this.isGameStart = false;
        this.propNode.active = false;
        this._lightScript.gameOver();
        this._gameInfoScript.gameOver();
        this.gameOverNode.active = true;  
        this._propScript.gameOver();
        //this._prisonerScript.gameOver();
        
        cc.audioEngine.uncache(this.bgMusic);
    },

    //分享到群复活
    comeBack: function () {
        //console.log("我又回来啦");
        let currentShareCount = parseInt(UserInfo.getString("shareWXCount"));
        let coinCount = parseInt(UserInfo.getString("coinCount"));
            if (currentShareCount > 0 && coinCount > 0) {
                currentShareCount--;
                coinCount--;
                UserInfo.setString("shareWXCount", currentShareCount);
                UserInfo.setString("coinCount", coinCount);

                this.gameOverNode.active = false;
                this.isGameStart = true;
                this.isBgRun = true;
                this.propNode.active = true;
                this._lightScript.onGameStart();
                this._prisonerScript.onGameStart();
        
                cc.audioEngine.playMusic(this.bgMusic, true, 1);

                if (UserInfo.platform == 1 && cc.vv.isRank) {
                    wx.postMessage({
                        method: 'hideRank',
                        data: "false"
                    });
                    cc.find("Canvas/PHB").active = false;
                }
                
            } else {
                UserInfo.setString("shareWXCount", 0);
            }
    },

    bgMove:function(speed){  
        var bgPositionY = this.bgNode.getPosition().y;
        var bg1PositionY = this.bg1Node.getPosition().y;
        
        this.bgNode.setPosition(cc.v2(0,bgPositionY - speed));
        this.bg1Node.setPosition(cc.v2(0,bg1PositionY - speed)); 
    },

    //检查是否要重置位置  
    checkBgReset:function(){  
        var bgYMax = this.bgNode.getContentSize().height;  
        if(this.bgNode.getPosition().y <= -bgYMax)
        {
            this.bgNode.setPosition(cc.v2(0,bgYMax-7));          //这里本来要设置成2001 会有缝隙 所以设置成小一点 有拼接
        }  
        if(this.bg1Node.getPosition().y <= -bgYMax)
        {
            this.bg1Node.setPosition(cc.v2(0,bgYMax-7));
        }
    },

    start () {
        this.feiendtex = new cc.Texture2D();
    },

    onTouchBegin: function (event) {
        
        if(this.isGameStart)
        {
            this._prisonerScript.prisonerStop();
            this.isBgRun = false;
        }
        
    },

    onTouchMove: function (event) {
        
    },

    onTouchEnd: function (event) {
        if(this.isGameStart)
        {
            this._prisonerScript.prisonerRun();
            this.isBgRun = true;
        }
    },

    onTouchEndShare: function (event) {
        this.hideNode();
    },

    hideNode: function () {
        if (this.ShareStrategyNode.active) {
            this.killTimer();
            this.ShareStrategyNode.active = false;
        }
    },

    onButtonRank: function (event, optData) {
        if (UserInfo.platform == 1 && cc.vv.isRank) {
            wx.postMessage({
                method: 'showFriendRank',
                data: optData
            });

            this.node.getChildByName("PHB").getChildByName("BtnPHBClose").active = (optData == "true");
            this.node.getChildByName("PHB").getChildByName("bg").active = (optData == "true");
        }                      
    },

    showRank() {
        if (UserInfo.platform == 1 && cc.vv.isRank) {

            let openDataContext = wx.getOpenDataContext();
            let sharedCanvas = openDataContext.canvas;

            this.feiendtex.initWithElement(sharedCanvas);
            this.feiendtex.handleLoadedTexture();

            this.feiendrank.spriteFrame = new cc.SpriteFrame(this.feiendtex);
            var scale = Math.min(750 / this.feiendtex.width, 1334 / this.feiendtex.height);
            this.feiendrank.node.setContentSize(this.feiendtex.width * scale, this.feiendtex.height * scale);
            this.node.getChildByName("PHB").active = true;
        }
    },

    onGoShop: function () {
        this.sceneManager.getComponent('SceneManager').changeCanvasByName('Shop');
    },

    onBackMain: function () {
        this.sceneManager.getComponent('SceneManager').changeCanvasByName('Main');
    },

    SaveImg: function () {
        if (UserInfo.platform == 1) {
            var path = UserInfo.ewmurl;
            WxCommon.SaveImageToPhotosAlbum(path, this, this.hideNode);
        }
    },

    addGold: function (event) {
        //console.log("捡到钱了~~");
        switch (event.detail.scoreType) {
            case 'gold':
            {
                let goldEffect = parseInt(event.detail.goldNum);
                UserInfo.addGold(goldEffect);
                this._gameInfoScript.addCurrGold(goldEffect);
                break;
            }                
        }
    },

    update (dt) {

        if (this.node.getChildByName("PHB").active == true) {
            this.showRank();
            //console.log("显示排行榜");
        }
        if(this.isBgRun)
        {
            this.bgMove(this.bgspeed);
            this.checkBgReset();  
        }
    },

    onCloseStrategy: function() {
        this.hideNode();
    },

    onShowOtherGame: function() {
        if (UserInfo.platform == 1) {
            var path = WxCommon.otherGameMap.get(this.otherGamesIndex);
            WxCommon.PreviewImage(path, this, this.hideNode);
        }
    },

    onShowStrategy: function () {
        this.ShareStrategyNode.active = true;
        this.createTimer();
    },

    // updateOtherGames: function(self) {
    //     self.otherGamesIndex = (self.otherGamesIndex + 1 + WxCommon.otherGameCount) % WxCommon.otherGameCount;
    //     self.createTimer();
    // },

    createTimer: function() {
        var self = this;
        var updateOtherGames = function() {
            self.otherGamesIndex = (self.otherGamesIndex + 1 + WxCommon.otherGameCount) % WxCommon.otherGameCount;
            self.ShareStrategyNode.getChildByName("othergames").getComponent(cc.Sprite).spriteFrame = self.SignAtlas.getSpriteFrame('games' + self.otherGamesIndex);
            self.createTimer();
        };

        if (this.ShareStrategyNode.active == true) {
            this.timerid = setTimeout(updateOtherGames,2000);
        }
    },

    killTimer: function() {
        if (this.timerid != null) {
            clearTimeout(this.timerid);
            this.timerid = null;
        }
    },
});
