// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html

cc.Class({
    extends: cc.Component,

    properties: {
        
        // scoreSpPrefab: {  //分数骨骼动画(飞机撞到金币、道具)
        //     default: null,
        //     type: cc.Prefab
        // },
        scoreGoldTipPrefab: { //加分提示动画(飘数字)
            default: null,
            type: cc.Prefab
        },

        shoutEffect: { //金币死亡音效
            default: null,
            url: cc.AudioClip
        },

        moveSpeedY: 5,
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () 
    {
        
        this._GameScript = this.node.parent.parent.getComponent('Gamejs');
        this._moveSpeedX = 2;
        this._isFlipx = false;
        this._timeCh = 0;

        this._isDead = false;
        this.setGoldMove();

        if (this.scoreGoldTipPrefab) {
            this._ScoreGoldTip = cc.instantiate(this.scoreGoldTipPrefab);
            this.node.parent.addChild(this._ScoreGoldTip);
            var randNum = Math.floor(Math.random()*6 + 1);
            this._ScoreGoldTip.getChildByName('ScoreTipTimeAniLabel').getComponent(cc.Label).string = randNum;
            this._ScoreGoldTip.active = false;
        }
    },

    setGoldMove: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a1", true);
    },

    setGoldLook:function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a2", true);
    },

    setGoldQuick: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a3", true);
    },

    setGoldDead: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a4", true);

        //播放音效
        cc.audioEngine.playEffect(this.shoutEffect, false, 1);
    },
    
    //碰撞检测
    onCollisionStay: function(other,self) {

        switch(other.tag) {
            case 1: {  //人物
                if(this._GameScript.isBgRun && this._isDead == false)
                {
                    console.log("被吃了。。。"+other.tag);
                    this.setGoldDead();
                    this.node.runAction(cc.sequence(cc.delayTime(0.8),cc.callFunc(this.setActive, this)));

                    this._isDead = true;
                    let evt = new cc.Event.EventCustom();
                    evt.type = "addGold";
                    evt.detail = {scoreType: "gold", goldNum: this._ScoreGoldTip.getChildByName('ScoreTipTimeAniLabel').getComponent(cc.Label).string};
                    gEvent.dispatchEvent(evt);

                    this._ScoreGoldTip.active = true;
                    this._ScoreGoldTip.getComponent(cc.Animation).play();
                    this._ScoreGoldTip.position = cc.p(this.node.position.x-25, this.node.position.y + 60);
                }
            }
            
            break;
        }
    },

    setActive: function()
    {
        cc.audioEngine.uncache(this.shoutEffect);
        this._ScoreGoldTip.active = false;
        this.node.stopAllActions();
        this.node.parent.getComponent('PropNodeJs').recycleStar(this.node);
    },

    checkGoldFlipx: function()
    {
        var positionX = this.node.getPosition().x;
        var positionY = this.node.getPosition().y; 
        if(positionX >= 300)
        {
            this.node.runAction(cc.flipX(true));
            this._isFlipx = true;
        }
        else if(positionX <= -300)
        {
            this.node.runAction(cc.flipX(false));
            this._isFlipx = false;
        }
    },

    changeSpeed: function(dt)
    {
        this._timeCh = 0;
        var randNum = parseInt(Math.random()*100);
        if(randNum < 70)
        {
            this._moveSpeedX = 2;
            this.setGoldMove();
        }
        else if(randNum >= 70 && randNum <85)
        {
            this._moveSpeedX = 0;
            this.setGoldLook();
        }
        else
        {
            this._moveSpeedX = 5;
            this.setGoldQuick();
        }
    },

    start () {

    },

    update (dt) 
    {
        if(this._isDead) return;
        this.checkGoldFlipx();
        this._timeCh+=dt;
        if(this._timeCh>3)
        {
            this.changeSpeed();
        }
        var positionX = this.node.getPosition().x;
        var positionY = this.node.getPosition().y; 
        if(this._GameScript.isBgRun)
        {
            this.node.setPosition(cc.v2(positionX,positionY - this.moveSpeedY));
        }

        if(this._isFlipx)
        {
            this.node.setPosition(cc.v2(positionX-this._moveSpeedX,this.node.getPosition().y));
        }
        else
        {
            this.node.setPosition(cc.v2(positionX+this._moveSpeedX,this.node.getPosition().y));
        }
    },
});
