// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html

cc.Class({
    extends: cc.Component,

    properties: {
        goldNode: {         //小鸡加分节点
            default: null,
            type: cc.Prefab
        },

        shieldNode: {         //盾牌隐身节点
            default: null,
            type: cc.Prefab
        },
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () 
    {
        this._goldPool = new cc.NodePool('PropJS');
        this._runDistance = 0;
        this._gameScript = this.node.parent.getComponent('Gamejs');
        this._gameInfoScript = this.node.parent.getChildByName("GameInfo").getComponent('GameInfoJs');
        this._isFirst = false;
    },

    onEnable: function() {
        //console.log("游戏开始，开始更新星星");
        
        this._goldPool.clear();
        
    },

    onDisable: function() {
        //console.log("游戏结束，删除所有子节点");
        
        this._goldPool.clear();
    },

    onGameStart: function()
    {
        this.node.removeAllChildren();
        this._runDistance = 0;
        this._isFirst = false;
    },

    gameOver: function()
    {
        this.node.removeAllChildren();
    },

    newProp: function()
    {
        this._runDistance = 0;
        var goldNode = cc.instantiate(this.goldNode);
        var randNum = parseInt(Math.random()*3);
        var positionY;
        if(randNum == 0)
        {
            positionY = 1000;
        }
        else if(randNum == 1)
        {
            positionY = 2400;
        }
        else
        {
            positionY = 3700;
        }
        goldNode.position = cc.v2(goldNode.getPosition().x,positionY);
        this.node.addChild(goldNode);
    },

    checkDestroy: function()
    {
        var propCnt = this.node.childrenCount;
        for(var i=0; i<propCnt; i++)
        {
            var nprop = this.node.children[i];
            if(nprop!=null)
            {
                if(nprop.getPosition().y <= -2000)
                {
                    this.node.removeChild(nprop);
                }
            }
        }
    },

    recycleStar: function(propnode)
    {
        this._goldPool.put(propnode);
    },

    start () {

    },

    update (dt) 
    {
        if(!this._gameScript.isGameStart) return;
        if(!this._gameScript.isBgRun) return;
        
        this._runDistance++;
        
        if(this._isFirst == false && this._runDistance==1)
        {
            var goldNode = cc.instantiate(this.goldNode);
            var randNum = parseInt(Math.random()*2);
            var positionY;
            if(randNum == 0)
            {
                positionY = 1000;
            }
            else
            {
                positionY = 2400;
            }
            goldNode.position = cc.v2(goldNode.getPosition().x,positionY);
            this.node.addChild(goldNode);
            this._isFirst = true;
        }
        else if(this._runDistance/25 - 32 >= 0)
        {
             this.newProp();
        }
        
        this.checkDestroy();
    },
});
