// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html

cc.Class({
    extends: cc.Component,

    properties: {

        leftlightPrefab1: { //左灯光1
            default: null,
            type: cc.Prefab,
            displayName: '左灯光1',
        },
        leftlightPrefab2: { //左灯光2
            default: null,
            type: cc.Prefab,
            displayName: '左灯光2',
        },
        leftlightPrefab3: { //左灯光3
            default: null,
            type: cc.Prefab,
            displayName: '左灯光3',
        },

        rightlightPrefab1: { //右灯光1
            default: null,
            type: cc.Prefab,
            displayName: '右灯光1',
        },
        rightlightPrefab2: { //右灯光2
            default: null,
            type: cc.Prefab,
            displayName: '右灯光2',
        },
        rightlightPrefab3: { //右灯光3
            default: null,
            type: cc.Prefab,
            displayName: '右灯光3',
        },
            
        newlightHeight: 500,    //灯光产生的高度间隔
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () 
    {
        this._leftArray = new Array();
        this._leftArray[0] = this.leftlightPrefab1;;
        this._leftArray[1] = this.leftlightPrefab2;;
        this._leftArray[2] = this.leftlightPrefab3;;
        this._rightArray = new Array();
        this._rightArray[0] = this.rightlightPrefab1;
        this._rightArray[1] = this.rightlightPrefab2;
        this._rightArray[2] = this.rightlightPrefab3;
        //this.setLightRotate();

        this._delyTimeArray = new Array(1, 0.8, 0.6);
        this._angleArray = new Array(60,45);
        this._rotateTimeArray = new Array(2.5,2,1.5);

        this._lastLight = null;//上次生成的灯光  用来判断下次生成灯光的类型
        this._gameScript = this.node.parent.getComponent('Gamejs');
        this._gameInfoScript = this.node.parent.getChildByName("GameInfo").getComponent('GameInfoJs');
    },

    newLight: function()
    {
        var newlight;
        if(this._lastLight == null)
        {
            var leftorRight = parseInt(Math.random()*2);
            if(leftorRight == 0)
            {
                newlight = cc.instantiate(this._leftArray[0]);
            }
            else
            {
                newlight = cc.instantiate(this._rightArray[0]);
            }
            newlight.position = cc.v2(newlight.getPosition().x,this.node.getPosition().y + 600);
        }
        else
        {
            if(this._lastLight._name.slice(0, 4) == "left")
            {
                var lightType = parseInt(Math.random()*3);
                newlight = cc.instantiate(this._rightArray[lightType]);
            }
            else
            {
                var lightType = parseInt(Math.random()*3);
                newlight = cc.instantiate(this._leftArray[lightType]);
            }
            //调整灯光距离概率
            var randNum = parseInt(Math.random()*10);
            var positonYplus;
            if(this._gameInfoScript.getGameLevel() == 1)
            {
                positonYplus = 600;
            }
            else if(this._gameInfoScript.getGameLevel() == 2)
            {
                if(randNum<6)
                {
                    positonYplus = 600;
                }
                else
                {
                    positonYplus = 400;
                }
            }
            else if(this._gameInfoScript.getGameLevel() == 3)
            {
                if(randNum<6)
                {
                    positonYplus = 400;
                }
                else
                {
                    positonYplus = 600;
                }
            }
            else
            {
                if(randNum<9)
                {
                    positonYplus = 400;
                }
                else
                {
                    positonYplus = 600;
                }
            }
            newlight.position = cc.v2(newlight.getPosition().x,this._lastLight.getPosition().y + positonYplus)
        }
        this._lastLight = newlight;
        this.node.addChild(newlight);

        //设置参数概率
        var nDelayTime, nAngle, nRotateTme;
        if(this._gameInfoScript.getGameLevel() == 1)
        {
            var randNum = parseInt(Math.random()*100);
            if(randNum < 50)
            {
                nDelayTime = this._delyTimeArray[0];
                nRotateTme = this._rotateTimeArray[0];
            }
            else if(randNum > 50 && randNum <= 75)
            {
                nDelayTime = this._delyTimeArray[1];
                nRotateTme = this._rotateTimeArray[1];
            }
            else
            {
                nDelayTime = this._delyTimeArray[2];
                nRotateTme = this._rotateTimeArray[2];
            }
        }
        else if(this._gameInfoScript.getGameLevel() == 2)
        {
            var randNum = parseInt(Math.random()*100);
            if(randNum < 40)
            {
                nDelayTime = this._delyTimeArray[2];
                nRotateTme = this._rotateTimeArray[2];
            }
            else if(randNum > 40 && randNum <= 70)
            {
                nDelayTime = this._delyTimeArray[0];
                nRotateTme = this._rotateTimeArray[0];
            }
            else
            {
                nDelayTime = this._delyTimeArray[2];
                nRotateTme = this._rotateTimeArray[1];
            }
        }
        else if(this._gameInfoScript.getGameLevel() == 3)
        {
            var randNum = parseInt(Math.random()*100);
            if(randNum < 60)
            {
                nDelayTime = this._delyTimeArray[2];
                nRotateTme = this._rotateTimeArray[2];
            }
            else if(randNum > 60 && randNum <= 80)
            {
                nDelayTime = this._delyTimeArray[0];
                nRotateTme = this._rotateTimeArray[0];
            }
            else
            {
                nDelayTime = this._delyTimeArray[1];
                nRotateTme = this._rotateTimeArray[1];
            }
        }
        else
        {
            var randNum = parseInt(Math.random()*100);
            if(randNum < 80)
            {
                nDelayTime = this._delyTimeArray[2];
                nRotateTme = this._rotateTimeArray[2];
            }
            else if(randNum > 80 && randNum <= 90)
            {
                nDelayTime = this._delyTimeArray[0];
                nRotateTme = this._rotateTimeArray[0];
            }
            else
            {
                nDelayTime = this._delyTimeArray[1];
                nRotateTme = this._rotateTimeArray[1];
            }
        }

        if(parseInt(Math.random()*4) < 3)
        {
            nAngle = 60;
        }
        else
        {
            nAngle = 45;
        }
        newlight.getComponent("lightJs").setMoveSpeed(nDelayTime, nAngle, nRotateTme);
        newlight.getComponent("lightJs").setLightRotate(nDelayTime, nAngle, nRotateTme);
    },

    checkDestroy: function()
    {
        var lightCnt = this.node.childrenCount;
        for(var i=0; i<lightCnt; i++)
        {
            var lightNode = this.node.children[i];
            if(lightNode!=null)
            {
                if(lightNode.getPosition().y <= -2000)
                {
                    this.node.removeChild(lightNode);
                }
            }
        }
    },

    onGameStart :function()
    {
        this.node.removeAllChildren();
    },

    gameOver: function()
    {
        for(var i = 0; i < this.node.childrenCount; i++)
        {
            this.node.children[i].stopAllActions();
        }
        this._lastLight = null;
        //this.node.removeAllChildren();
    },

    start () {

    },

    update (dt) {

        if(this._gameScript.isGameStart)        //在游戏状态下才生成,销毁
        {
            var randNum = parseInt(Math.random()*100);
            if(this._lastLight == null || this._lastLight.getPosition().y < 800)
            {
                this.newLight();
            }

            this.checkDestroy();
        }
        
    },
});
