// Learn cc.Class:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/class/index.html
// Learn Attribute:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/reference/attributes/index.html
// Learn life-cycle callbacks:
//  - [Chinese] http://www.cocos.com/docs/creator/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/editors_and_tools/creator-chapters/scripting/life-cycle-callbacks/index.html

cc.Class({
    extends: cc.Component,

    properties: {
        
        deadEffect: { //死亡音效
            default: null,
            url: cc.AudioClip
        },

        creepEffect: { //爬行音效
            default: null,
            url: cc.AudioClip
        },

        invisableEffect: { //爬行音效
            default: null,
            url: cc.AudioClip
        },
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () 
    {
        this._gameScript = this.node.parent.parent.getComponent('Gamejs');
    },

    onGameStart: function()
    {
        this.prisonerRun();
    },

    //跑
    prisonerRun: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a1", true);

        //播放音效
        cc.audioEngine.playEffect(this.creepEffect, true, 1);
    },

    //隐身
    prisonerStop: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a2", true);

        //暂停音效
        cc.audioEngine.uncache(this.creepEffect);
        //播放音效
        cc.audioEngine.playEffect(this.invisableEffect, false, 1);
    },

    //死亡
    prisonerDead: function()
    {
        var prisonersk = this.node.getComponent(sp.Skeleton);
        prisonersk.setAnimation(0, "a3", false);
    },
    

    //碰撞检测
    onCollisionStay: function(other,self) {
        switch(other.tag) {
            case 0: {  //灯光
                if(this._gameScript.isBgRun)
                {
                    console.log("被发现了。。。"+other.tag);
                    this._gameScript.gameOver();
                    this.prisonerDead();

                    cc.audioEngine.uncache(this.creepEffect);
                    //播放音效
                    cc.audioEngine.playEffect(this.deadEffect, false, 1);
                }

            }
            break;
        }
    },

    start () {

    },

    // update (dt) {},
});
